/*	-*-C-*- (Just help Emacs)
**	Name	:	cyril
**	Date	:	Sat Jan 15 12:17:36 1994
**	Subjetc	:	The main part of the driver
**	File	:	dpt.c
**	Modif	:	Fri Feb  4 00:27:18 1994
**	Version	:	$Id$
*/

/*
** $Log$
*/ 

/* Info 
   Thank for the scsi team (Merci), and of corse
   the little documentation of the dpt, where you must 
   read, read, read the poor two lines (tired)
   but now, it's seems to work not too bad (it's never too late).
   The dpt board it seem to be very performant board, i have a 
   adaptech 1742, and the dpt is faster.
   And i forget linus.
   I find with linux a OS that is better that i ever try, i try
   dos, windows, os/2, unixware, sco ;-(, nextstep ... (exect OS/9)
   and he transform my 486DX50 in a monster, that different with 
   unixware that it was just enaught 
   So have fun linuxer */

#include <linux/kernel.h>
#include <linux/head.h>
#include <linux/types.h>
#include <linux/string.h>
#include <linux/ioport.h>
#include <linux/in.h>

#include <linux/sched.h>
#include <asm/dma.h>

#include <asm/system.h>
#include <asm/io.h>
#include "../block/blk.h"
#include "scsi.h"
#include "hosts.h"

#include "dpt.h"


/* Global variable ( i hate ) */

static unsigned int Bit;
static ushort   baseadr;

static struct dpt_ccb_cp cp[DPT_MAILBOXES];
static struct dpt_ccb_sp sp[DPT_MAILBOXES]; 

/* For Isa and Eisa */
/*ushort dpt_iobase[] = { 0x170, 0x1f0, 0x230,0x330, 0x1c88, 0x2c88,0x3c88,0x0  };*/

/* For Eisa Board */
static ushort dpt_iobase[] = { 0x1c88, 0x2c88,0x3c88,0x0  };

static ushort *dpt_base = dpt_iobase;
static volatile int internal_done_flag = 0;
static volatile int internal_done_errcode = 0;

/* 
** Send a PIO command (Just for detect the board)
*/

unchar send_dpt_cmd(ushort iobase, unchar cmd) {
 volatile unsigned int timeout = TIMEOUT;

cli();
while (( ((inb(iobase+7) & 0x80)== 0x80) ^ !--timeout ));

 if ( !timeout ) 
   return -1;

 /* No timeout Send the command */

 outb(cmd,iobase+7);
 sti();
 return 0;
}

/*
** Like the name send DPT DMA Command 
*/

unchar send_dpt_dma(ushort iobase, unsigned int adr) {
 register unsigned int timeout = TIMEOUT*2;

  /* Wait for the Busy */
 cli();

 while (( ((inb(iobase+7) & 0x80) == 0x80) ^ !--timeout ));

 /* A timeout occur */
 if ( !timeout ) 
   return(1);

  outb( (char) adr, iobase+2);
  outb( (char) (adr>>8), iobase+3);
  outb( (char) (adr>>16), iobase+4);
  outb( (char) (adr>>24), iobase+5);

 /* Every think perfect */

 outb(0xFF,iobase+7);

 sti();
 return(0);
}

/*
** Configure the dpt 
*/

unchar set_dpt_dma(ushort iobase, unsigned int adr) {
 register unsigned int timeout = TIMEOUT*2;

  /* Wait for the Busy */
 cli();

 while (( ((inb(iobase+7) & 0x80) == 0x80) ^ !--timeout ));

 /* A timeout occur */
 if ( !timeout ) 
   return(1);

  outb( (char) adr, iobase+2);
  outb( (char) (adr>>8), iobase+3);
  outb( (char) (adr>>16), iobase+4);
  outb( (char) (adr>>24), iobase+5);

 /* Every think perfect */

 outb(0xFE,iobase+7);

 sti();
 return(0);
}

/*
** Read Info 
*/

unchar read_dpt_info(struct dpt_info *info, ushort iobase)  {
register unsigned int timeout=TIMEOUT;
register unsigned int i=0 ;
ushort *p = (ushort *)info;
register unchar flag=FALSE; 

 deb: 

while ( !(inb(iobase+7) & 0x8) ^ !--timeout);
cli();
if (!timeout && !flag) 
  return(-1);   /* Timeout ! */
else
  if ( !timeout && flag )
    return(0);

p[i++] = inw(iobase);

if ( i == 9 ) /* Looking for the EATA signature */
  if (info->sign != 0x41544145)
    return(-1); /* This is not a dpt */
  else
    flag=TRUE;

goto deb;

return(0);
}

/*
 ** This Fonction detect the dpt board
 */
     
int dpt_detect(int hostnum) {
  struct dpt_info ccb_info;
  struct dpt_config ccb_config;
  unsigned int ij ;
  unchar dma_trans[] = { 0, 7, 6, 5 };
  
  Bit = 0;
/*
** Make EOC Clear
*/

  for(ij=0;ij<DPT_MAILBOXES;ij++)
    sp[ij].eoc = 0 ;

/*
** Try to find a board
*/

  while ( *dpt_base ) {

    if ( !send_dpt_cmd(*dpt_base, 0xF0) && !read_dpt_info(&ccb_info,*dpt_base)  )  
      break;
    else 
     dpt_base++;
  }

  /* I detect nothink ;-( snif*/
  if (!*dpt_base) 
    return(0);

  /* DMA Support ? */
  if (!ccb_info.dmasup)
    return(0); 

  /* ;-) i get on */
  baseadr = *dpt_base;

/* Reset Not need for the moment but ? */
/*  send_dpt_cmd(baseadr,0xf9); */

/* Find the irq */
  if (request_irq(ccb_info.irq,dpt_intr)){
    printk("DPT : Unable to allocate IRQ for dpt controller.");
    return(0);
  }

/* Set the dma */

/*
** A bug of the DPT for the moment i don't know
** But i can't detect automaticly the DMA Chanel, Why ? DPT Help !!
*/

/*
   if (ccb_info.drqvld )
  if(request_dma(dma_trans[ccb_info.drqx])) {
    printk("DPT : Unable to allocate DMA for dpt controller.");
    return(0);
  }
  else 
    printk("Warning : DPT DRQ Not Valid");
*/

/* I hard code the dma chanel for the moment ;-( */

  if(request_dma(5)) {
    printk("DPT : Unable to allocate DMA for dpt controller.");
    return(0);
  }    

  printk("\nDpt Find at IO %x IRQ %d DMA %x ", baseadr, ccb_info.irq, 5);

  scsi_hosts[hostnum].sg_tablesize = (ushort )ntohs(ccb_info.scatt_size);
  scsi_hosts[hostnum].this_id = (ushort )ntohl(ccb_info.host_adr);

  /* Set config */
  ccb_config.len = (ushort) ntohs((ushort)510);
  ccb_config.edis =  0;
  ccb_config.ocena = 1;
  ccb_config.mdpena = 1;
  ccb_config.tarena =0 ;
  ccb_config.nul = 0;
  ccb_config.zero = 0;

  if (set_dpt_dma(baseadr,(unsigned int)&ccb_config)) 
    printk("Trobble send config");
  
  return(1);
}

/*
** Return a info string
*/

const char *dpt_info(void) {
  return("Driver for DPT board");
}

/*
** Work With dpt_command
*/

static void internal_done(Scsi_Cmnd * SCpnt) {
    internal_done_errcode = SCpnt->result;
    ++internal_done_flag;
}

/*
** Work ?
*/

int dpt_command(Scsi_Cmnd *SCpnt) {
    dpt_queuecommand(SCpnt, internal_done);

    while (!internal_done_flag);
    internal_done_flag = 0;
    return internal_done_errcode;
}

/*
** The main Part of the driver ( What a job )
*/

int dpt_queuecommand(Scsi_Cmnd *SDcmd, void (*done)(Scsi_Cmnd *)) {
  unsigned int i,j ;
  struct sg *sgptr;
  struct scatterlist *sgpnt;


  cli();

  if(*SDcmd->cmnd == REQUEST_SENSE)
    {

      if ( SDcmd->request_bufflen != sizeof(SDcmd->sense_buffer))
	{
	  printk("Wrong buffer length supplied for request sense ");
	  panic("Dpt ");
        }
      SDcmd->result = 0;
      done(SDcmd); 
      return 0;
    } 

/*
** Find a free sp, in a bit list 
*/

  for(i=0; (i < (sizeof(Bit)*8)) & !( ~Bit & (1<<i)) ; i++);

  if ( i != (sizeof(Bit)*8))   
    Bit |= (1<<i);
  else 
    printk("Attention probleme allocation cp\n");

  sti();

  memset(&cp[i], 0, sizeof(struct dpt_ccb_cp));
  cp[i].sp_adr= ntohl((unsigned int) &sp[i]);
  SDcmd->scsi_done=done;

  /* Position for Write or Read */
  if (SDcmd->cmnd[0] == WRITE_10 || SDcmd->cmnd[0] == WRITE_6)
    cp[i].dout=1,cp[i].din=0;
  else
    cp[i].dout=0,cp[i].din=1;

  cp[i].intr=0;  cp[i].nul=0;    cp[i].reqsen=1;
  cp[i].init=0;  cp[i].sreset=0;  cp[i].phsunit=0;  cp[i].devadr=SDcmd->target;

  /* Mess */

  cp[i].lun=SDcmd->lun;  
  cp[i].zero1=0;  cp[i].zero2=0;  cp[i].luntar=0;  cp[i].dispri=1;  cp[i].one=1;
  cp[i].mess1=0;  cp[i].mess2=0;  cp[i].mess3=0;  

  cp[i].vir_cp=(unsigned int) SDcmd;

  cp[i].unused[0] = 0 ;   cp[i].unused[1] = 0 ;   cp[i].unused[2] = 0 ;   cp[i].unused[3] = 0 ; 
  cp[i].notused=0;

  /* Take the value in the scsi.h file for the sens buffer */

  cp[i].rsl=16;
 
  cp[i].res_sens_adr=ntohl((unsigned int) SDcmd->sense_buffer); 
/*  cp[i].res_sens_adr=ntohl((unsigned int) sp[i].sense);*/

  if (SDcmd->use_sg)
    {

      /* Use the scather/gather mode */
      cp[i].sg=1;
/*
** Made the Scatter/Gather List
*/
      SDcmd->host_scribble = (unsigned char *) scsi_malloc( ( (SDcmd->use_sg*sizeof(struct sg)/512)+1)*512 );
      sgptr = (struct sg *) SDcmd->host_scribble;
      sgpnt = (struct scatterlist *) SDcmd->request_buffer;  
      
      if (!sgptr) panic("Dpt : Can't allocate Memory");

      for(j=0;j<SDcmd->use_sg;j++) {
	sgptr[j].adress = ntohl((unsigned int) sgpnt[j].address);
	sgptr[j].len= ntohl((unsigned int) sgpnt[j].length);
      }

      cp[i].data_adr= ntohl((unsigned int) sgptr);
      cp[i].data_trans_len=ntohl( (SDcmd->use_sg*sizeof(struct sg)) );
    }
  else {
    cp[i].sg=0 ;
    SDcmd->host_scribble = NULL ;
    cp[i].data_adr= ntohl((unsigned int) SDcmd->request_buffer);
    cp[i].data_trans_len=ntohl(SDcmd->request_bufflen);
  }

  /* Copy the Command */

  memcpy(cp[i].cdb,SDcmd->cmnd,COMMAND_SIZE(*SDcmd->cmnd));

  if (send_dpt_dma(baseadr,(unsigned int)&cp[i])) {
    printk("Timeout Send dma");
    SDcmd->result = DID_TIME_OUT << 16 ; 
    SDcmd->scsi_done(SDcmd);    
    Bit ^= (1<<i);
  }
  
  return(0);
}

/*
** Abort 
*/

int dpt_abort(Scsi_Cmnd *cmd, int code) {

/* They told me to do nothing so .. */
  return 0;
}

/*
** The Reset routine
*/

int dpt_reset(Scsi_Cmnd *scd_cmd) {
  unsigned int i;

  cli();

/*
** Find a free sp, in a bit list 
*/

  for(i=0; (i < (sizeof(Bit)*8)) & !( ~Bit & (1<<i)) ; i++);

  if ( i != (sizeof(Bit)*8))   
    Bit |= (1<<i);
  else 
    printk("Attention probleme allocation cp\n");

  sti();

  memset(&cp[i], 0, sizeof(struct dpt_ccb_cp));

  /* Some Parameters */

  scd_cmd->scsi_done=internal_done;
  scd_cmd->host_scribble = NULL ;
  cp[i].sp_adr= ntohl((unsigned int) &sp[i]);
  cp[i].res_sens_adr=ntohl((unsigned int) scd_cmd->sense_buffer); 
  cp[i].data_adr= ntohl((unsigned int) scd_cmd->request_buffer);
  cp[i].din=1;
  cp[i].reqsen=1;  cp[i].init=1;   cp[i].devadr=scd_cmd->target;
  cp[i].lun=scd_cmd->lun;  cp[i].one=1;
  cp[i].rsl=16;
  cp[i].data_trans_len=ntohl(scd_cmd->request_bufflen);

  if (send_dpt_dma(baseadr,(unsigned int)&cp[i])) {
    printk("DPT : Reset Timeout");
    return(-1);
  }

if (scd_cmd)
     scd_cmd->flags |= NEEDS_JUMPSTART;

  return(0);
}

/*
** I am not sure it is Ok
*/

int dpt_biosparam(int size, int dev,int *ip) {

  ip[0] = 64;
  ip[1] = 32;
  ip[2] = size >> 11;
  return(0);
}

/*
** Interrup handle
*/

void dpt_intr(int foo) {
  Scsi_Cmnd *scd=NULL;
  unchar ret_code;

  /*
   ** Find the Sp Free it And
   ** Return to Done
   */

  /* Free intr */
  /* 
   ** Don't even think the return code are Good
   ** it is only a joke from DPT, and thank you 
   ** DPT i look for a log time for this bug 
   ** I just want to tell you. Na !!
   */  
  inb(baseadr+REG_STATUS);

/*
** Looking for all the sp return 
*/
  
  for( ret_code=0; ret_code < 32; ret_code++) {
    if (sp[ret_code].eoc == 1) { 
      sp[ret_code].eoc=0;
      Bit ^= (1<<ret_code);
      scd=(Scsi_Cmnd *) sp[ret_code].vir_cp;

      if (scd)   {

/* Free the memory, if needed */
 
    if (scd->host_scribble) 
      scsi_free(scd->host_scribble, ( (scd->use_sg*sizeof(struct sg)/512)+1)*512 );

  /*
   ** Look for the error message 
   */

  switch(sp[ret_code].cont_stat) {

    case 0:			/* No Error */
    scd->result = DID_OK << 16 | sp[ret_code].scsi_stat;
    break ;

    case 1:			/* Selection Time Out */
    case 2:			/* Command Time Out   */
      scd->result = DID_TIME_OUT << 16 | sp[ret_code].scsi_stat;
      break ;
      
    case 3:			/* SCSI Bus Reset Receive */
      scd->result = DID_RESET << 16 | sp[ret_code].scsi_stat;
      break ;
    case 4:			/* Initial Controller Power-up */
    case 5:			/* Unexpected Bus Phase */
    case 6:			/* Unexpected Bus Free */
      scd->result = DID_ERROR << 16 | sp[ret_code].scsi_stat;
      break ;
    
    case 7:			/* Bus Parity Error */
      scd->result = DID_PARITY << 16 | sp[ret_code].scsi_stat;
      break ;
    case 8:			/* SCSI Hung */
    case 9:			/* Unexpected Message Reject */
    case 0xa:			/* SCSI Bus Reset Stuck */
    case 0xb:			/* Auto Request-Sens Failed */
      scd->result = DID_ERROR << 16 | sp[ret_code].scsi_stat;
      break ;

    case 0xc:			/* Controller Ram Parity */
      scd->result = DID_PARITY << 16 | sp[ret_code].scsi_stat;
      break ;
    }

/* And then say a little Hello to the scsi ;-) */

  if (scd->scsi_done) 
    scd->scsi_done(scd);
  }}}}

